#version 300 es
precision highp float;
precision highp int;

uniform mat4 u_View;
uniform mediump sampler2D _AlbedoTexture;
uniform mediump sampler2D _MatCapTexture;

in vec2 v_uv0;
in vec3 v_nDirWS;
layout(location = 0) out vec4 o_fragColor;

void main()
{
    vec2 uv = v_uv0;
    vec3 normal = v_nDirWS;
    normal = normalize((u_View * vec4(normal, 0.0)).xyz);
    vec4 albedo = texture(_AlbedoTexture, uv);
    vec2 matcapUV = (normal.xy * 0.5) + vec2(0.5);
    matcapUV.y = 1.0 - matcapUV.y;
    vec4 matcapCol = texture(_MatCapTexture, matcapUV);
    o_fragColor = albedo * matcapCol;
}

