#version 300 es

uniform mat4 u_Palatte[50];
uniform mat4 u_Model;
uniform mat4 u_TransposeInvModel;
uniform mat4 u_MVP;
uniform vec2 _Offset;
uniform vec2 _Tiling;
uniform float _Rotation;

layout(location = 3) in vec4 attBoneIds;
layout(location = 4) in vec4 attWeights;
layout(location = 0) in vec3 attPosition;
layout(location = 2) in vec3 attNormal;
out vec3 v_posWS;
out vec3 v_nDirWS;
out vec2 v_uv0;
layout(location = 1) in vec2 attTexcoord0;

vec2 UV_TRS(vec2 inputUV, vec2 uvCenter, vec2 uvPan, vec2 uvScale, float uvRotate)
{
    vec2 minusCenterUV = inputUV - uvCenter;
    float cosVal = cos(uvRotate);
    float sinVal = sin(uvRotate);
    mat2 rotateMat = mat2(vec2(cosVal, -sinVal), vec2(sinVal, cosVal));
    vec2 outputUV = minusCenterUV * uvScale;
    outputUV = (rotateMat * outputUV) + uvCenter;
    outputUV += uvPan;
    return outputUV;
}

void main()
{
    mat4 _79 = u_Palatte[int(attBoneIds.x)] * attWeights.x;
    mat4 _88 = u_Palatte[int(attBoneIds.y)] * attWeights.y;
    mat4 _101 = mat4(_79[0] + _88[0], _79[1] + _88[1], _79[2] + _88[2], _79[3] + _88[3]);
    mat4 _110 = u_Palatte[int(attBoneIds.z)] * attWeights.z;
    mat4 _123 = mat4(_101[0] + _110[0], _101[1] + _110[1], _101[2] + _110[2], _101[3] + _110[3]);
    mat4 _132 = u_Palatte[int(attBoneIds.w)] * attWeights.w;
    mat4 boneTransform = mat4(_123[0] + _132[0], _123[1] + _132[1], _123[2] + _132[2], _123[3] + _132[3]);
    vec4 bm_postiton = boneTransform * vec4(attPosition, 1.0);
    vec3 bn_normal = (boneTransform * vec4(attNormal, 0.0)).xyz;
    v_posWS = (u_Model * bm_postiton).xyz;
    v_nDirWS = (u_TransposeInvModel * vec4(bn_normal, 0.0)).xyz;
    gl_Position = u_MVP * bm_postiton;
    v_uv0 = vec2(attTexcoord0.x, 1.0 - attTexcoord0.y);
    vec2 param = v_uv0;
    vec2 param_1 = vec2(0.5);
    vec2 param_2 = _Offset;
    vec2 param_3 = _Tiling;
    float param_4 = _Rotation / 57.295780181884765625;
    v_uv0 = UV_TRS(param, param_1, param_2, param_3, param_4);
}

